import { D as DiffPatcher } from './date-reviver.mjs';
export { d as dateReviver } from './date-reviver.mjs';
import './diff.mjs';
import './contexts/context.mjs';
import './contexts/patch.mjs';
import './contexts/reverse.mjs';
import './filters/trivial.mjs';
import './filters/nested.mjs';
import './filters/arrays.mjs';
import './filters/lcs.mjs';
import './filters/dates.mjs';
import './filters/texts.mjs';

function create(options) {
    return new DiffPatcher(options);
}
let defaultInstance;
function diff(left, right) {
    if (!defaultInstance) {
        defaultInstance = new DiffPatcher();
    }
    return defaultInstance.diff(left, right);
}
function patch(left, delta) {
    if (!defaultInstance) {
        defaultInstance = new DiffPatcher();
    }
    return defaultInstance.patch(left, delta);
}
function unpatch(right, delta) {
    if (!defaultInstance) {
        defaultInstance = new DiffPatcher();
    }
    return defaultInstance.unpatch(right, delta);
}
function reverse(delta) {
    if (!defaultInstance) {
        defaultInstance = new DiffPatcher();
    }
    return defaultInstance.reverse(delta);
}
function clone(value) {
    if (!defaultInstance) {
        defaultInstance = new DiffPatcher();
    }
    return defaultInstance.clone(value);
}

export { DiffPatcher, clone, create, diff, patch, reverse, unpatch };
